// mssg.cc, user message interface classes,
// mssg  -- underlined error,
// cmssg -- colored error.

#include <forint/mssg.hh>

namespace FInt {

// method to be rewritten for a `mssg' inheritor...
void mssg::
flsh()
{
  uint i=0;
  uint j=0;
  char tmp[100];

// print string with pointed error...
  if (u_str_message.size()) {
// `typewriter' print...
    if (slp)
      while (i<u_str_message.size()) {
	if (u_str_message[i] == '\033') {
	  j=0;
	  while (i<u_str_message.size() && u_str_message[i] != 'm') {
	    tmp[j] = u_str_message[i];
	    ++i;
	    ++j;
	  }
	  tmp[j] = u_str_message[i];
	  tmp[j+1] = '\0';
	  cout << tmp << flush;
	  ++i;
	}
	if (i>=u_str_message.size()) break;
	usleep(slp);
	cout << u_str_message[i] << flush;
	++i;
      }
// usual print...
    else
      cout << u_str_message << flush;

// clearing...
    u_str_message = "";
  }

// print message...
  if (u_message.size()) {
// `typewriter' print...
    i=0;
    j=0;
    if (slp)
      while (i<u_message.size()) {
	if (u_message[i] == '\033') {
	  j=0;
	  while (i<u_message.size() && u_message[i] != 'm') {
	    tmp[j] = u_message[i];
	    ++i;
	    ++j;
	  }
	  tmp[j] = u_message[i];
	  tmp[j+1] = '\0';
	  cout << tmp << flush;
	  ++i;
	}
	if (i>=u_message.size()) break;
	usleep(slp);
	cout << u_message[i] << flush;
	++i;
      }
// usual print...
    else
      cout << u_message << flush;

// clearing...
    u_message = "";
  }
}

void mssg::
err(const char* p, uint s,
    const char* message, uint force=0)
{
  substr_beg = (char*)p;
  substr_len = s;
  if (p)
    u_str_message += string(str) + '\n';
  //cerr << "------";
  if (p && p < str)
if (!locale)
  cerr << "forint internal error.\n";
else
  cerr << "  forint.\n";

  else if (s) {
    while (p-- > str)
      u_str_message += '-';
    while (s--)
      u_str_message += '^';
    u_str_message += '\n';
  }
if (!locale)
  u_message += string(emess ? emess : "Error: ") + message;
else
  u_message += string(emess ? emess : ": ") + message;

}

// the number of characters MUST BE pointed !!!
void mssg::
err(const char message, uint n, uint force=0)
{
  while (n--) u_message += message;
}
void mssg::
err(const double message, uint force=0)
{
  char tmp[100];
  ostrstream ostr(tmp,100);
  ostr.precision(dbl_precision);
  ostr << message << ends;
  u_message += tmp;
}
void mssg::
err(const string message, uint force=0)
{
  u_message += message;
}

void mssg::
warn(const char* p, uint s,
     const char* message, uint force=0)
{
  substr_beg = (char*)p;
  substr_len = s;
  if (p)
    u_str_message += string(str) + '\n';
  //cout << "------";
  if (p && p < str)
if (!locale) {
    cerr << "forint internal error.\n";
} else {
    cerr << "  forint.\n";
}
  else if (s) {
    while (p-- > str)
      u_str_message += '-';
    while (s--)
      u_str_message += '^';
    u_str_message += '\n';
  }
if (!locale) {
  u_message += string(wmess ? wmess : "Warning: ") + message;
} else {
  u_message += string(wmess ? wmess : ": ") + message;
}
}

// the number of characters MUST BE pointed !!!
void mssg::
warn(const char message, uint n, uint force=0)
{
  while (n--) u_message += message;
  u_message += message;
}
void mssg::
warn(const double message, uint force=0)
{
  char tmp[100];
  ostrstream ostr(tmp,100);
  ostr.precision(dbl_precision);
  ostr << message << ends;
  u_message += tmp;
}
void mssg::
warn(const string message, uint force=0)
{
  u_message += message;
}

void mssg::
mess(int s, const char* message,
     colorEnum c1=fg_default, colorEnum c2=bg_default,
     bool bold=false)
{
  u_message += message;
}

// the number of characters MUST BE pointed !!!
void mssg::
mess(const char message, uint n,
     colorEnum c1=fg_default, colorEnum c2=bg_default,
     bool bold=false)
{
  while (n--) u_message += message;
}
void mssg::
mess(const double message,
     colorEnum c1=fg_default, colorEnum c2=bg_default,
     bool bold=false)
{
  char tmp[100];
  ostrstream ostr(tmp,100);
  ostr.precision(dbl_precision);
  ostr << message << ends;
  u_message += tmp;
}
void mssg::
mess(const string message,
     colorEnum c1=fg_default, colorEnum c2=bg_default,
     bool bold=false)
{
  u_message += message;
}

/*****************************************************************************
*/

void cmssg::
err(const char* p, uint s,
    const char* message, uint force=0)
{
  substr_beg = (char*)p;
  substr_len = s;
  if (p && p < str)
if (!locale) {
    cerr << "forint internal error.\n";
} else {
    cerr << "  forint.\n";
}
  else if (s) {
    u_str_message += "      ";
    if (p-str)
      u_str_message += string_str.substr(0,p-str);
    u_str_message += ((string)"\033[01;31m" + string_str.substr(p-str,s) +
		  (string)"\033[00m");
    if (p-str+s < size)
      u_str_message += string_str.substr(p-str+s,size-(p-str+s));
    u_str_message += '\n';
  }
  u_message += ((force) ? "\033[05;31m" : "\033[31m");
if (!locale) {
  u_message += string(emess ? emess : "Error: ") + message;
} else {
  u_message += string(emess ? emess : ": ") + message;
}
  u_message += "\033[00m";
}

// the number of characters MUST BE pointed !!!
void cmssg::
err(const char message, uint n, uint force=0)
{
  u_message += ((force) ? "\033[05;31m" : "\033[31m");
  while (n--) u_message += message;
  u_message += "\033[00m";
}
void cmssg::
err(const double message, uint force=0)
{
  u_message += ((force) ? "\033[05;31m" : "\033[31m");
  char tmp[100];
  ostrstream ostr(tmp,100);
  ostr.precision(dbl_precision);
  ostr << message << ends;
  u_message += string(tmp) + "\033[00m";
}
void cmssg::
err(const string message, uint force=0)
{
  u_message += ((force) ? "\033[05;31m" : "\033[31m") +
    message + "\033[00m";
}

void cmssg::
warn(const char* p, uint s,
     const char* message, uint force=0)
{
  substr_beg = (char*)p;
  substr_len = s;
  if (p && p < str)
if (!locale) {
    cerr << "forint internal error.\n";
} else {
    cerr << "  forint.\n";
}
  else if (s) {
    u_str_message += "      ";
    if (p-str)
      u_str_message += string_str.substr(0,p-str);
    u_str_message += ((string)"\033[05;33m" + string_str.substr(p-str,s) +
		  (string)"\033[00m");
    if (p-str+s < size)
      u_str_message += string_str.substr(p-str+s,size-(p-str+s));
    u_str_message += '\n';
  }
  u_message += ((force) ? "\033[05;33m" : "\033[33m");
if (!locale) {
  u_message += string(wmess ? wmess : "Warning: ") + message;
} else {
  u_message += string(wmess ? wmess : ": ") + message;
}
  u_message += "\033[00m";
}

// the number of characters MUST BE pointed !!!
void cmssg::
warn(const char message, uint n, uint force=0)
{
  u_message += ((force) ? "\033[05;33m" : "\033[33m");
  while (n--) u_message += message;
  u_message += "\033[00m";
}
void cmssg::
warn(const double message, uint force=0)
{
  u_message += ((force) ? "\033[05;33m" : "\033[33m");
  char tmp[100];
  ostrstream ostr(tmp,100);
  ostr.precision(dbl_precision);
  ostr << message << ends;
  u_message += string(tmp) + "\033[00m";
}
void cmssg::
warn(const string message, uint force=0)
{
  u_message += ((force) ? "\033[05;33m" : "\033[33m") +
    message + "\033[00m";
}

void cmssg::
mess(int s, const char* message,
     colorEnum c1=fg_default, colorEnum c2=bg_default,
     bool bold=false)
{
  char buf[100];
  ostrstream ostr(buf,100);
  ostr << "\033[" << (bold ? "05;" : "")
       << int(c1) << ";" << int(c2) << "m" << ends;
  u_message += string(buf) + message + "\033[00m";
}

// the number of characters MUST BE pointed !!!
void cmssg::
mess(const char message, uint n,
     colorEnum c1=fg_default, colorEnum c2=bg_default,
     bool bold=false)
{
  char buf[100];
  ostrstream ostr(buf,100);
  ostr << "\033[" << (bold ? "05;" : "")
       << int(c1) << ";" << int(c2) << "m" << ends;
  u_message += buf;
  while (n--) u_message += message;
  u_message += "\033[00m";
}
void cmssg::
mess(const double message,
     colorEnum c1=fg_default, colorEnum c2=bg_default,
     bool bold=false)
{
  char buf[100];
  ostrstream ostr(buf,100);
  ostr << "\033[" << (bold ? "05;" : "")
       << int(c1) << ";" << int(c2) << "m" << ends;
  u_message += buf;
  char tmp[100];
  ostrstream ostr2(tmp,100);
  ostr2.precision(dbl_precision);
  ostr2 << message << ends;
  u_message += string(tmp) + "\033[00m";
}
void cmssg::
mess(const string message,
     colorEnum c1=fg_default, colorEnum c2=bg_default,
     bool bold=false)
{
  char buf[100];
  ostrstream ostr(buf,100);
  ostr << "\033[" << (bold ? "05;" : "")
       << int(c1) << ";" << int(c2) << "m" << ends;
  u_message += buf + message + "\033[00m";
}

void mssg::
init(void)
{
  str = 0;
  size = 0;
  cout.precision(DBL_DIG);
  u_message = "";
  slp = 0;
  substr_beg = 0;
  substr_len = 0;
  emess = 0;
  wmess = 0;

  char* t1 = getenv("LC_MESSAGES");
  char* t2 = getenv("LC_ALL");

  locale =
    (t1 && !strcmp(t1,"ru_RU.KOI8-R") ||
     t2 && !strcmp(t2,"ru_RU.KOI8-R"))
    ? 1
    : 0;
}

}
